/* GEM Resource C Source */

#include <portab.h>
#include <aes.h>
#include "LET_LGHT.H"

#if !defined(WHITEBAK)
#define WHITEBAK    0x0040
#endif
#if !defined(DRAW3D)
#define DRAW3D      0x0080
#endif

#define FLAGS9  0x0200
#define FLAGS10 0x0400
#define FLAGS11 0x0800
#define FLAGS12 0x1000
#define FLAGS13 0x2000
#define FLAGS14 0x4000
#define FLAGS15 0x8000
#define STATE8  0x0100
#define STATE9  0x0200
#define STATE10 0x0400
#define STATE11 0x0800
#define STATE12 0x1000
#define STATE13 0x2000
#define STATE14 0x4000
#define STATE15 0x8000

TEDINFO rs_tedinfo[] =
{ "X",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x1100, 0, 0, 2, 1,
  "X",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, 0, 2, 1,
  "My Man\047s Gone Now.",
  "\0",
  "\0",
  SMALL, 0, TE_LEFT , 0x1100, 0, 0, 19, 1,
  "Man fliegt nicht mehr ohne ...",
  "\0",
  "\0",
  SMALL, 0, TE_LEFT , 0x1100, 0, 0, 31, 1
};

OBJECT rs_object[] =
{ 
  /******** Tree 0 INFOPAGE ****************************************************/
        -1, INFOVERS,        6, G_BOX     |0x8900,   /* Object 0  */
  FLAGS10|FLAGS11|FLAGS14, OUTLINED, (LONG)0x00021100L,
  0x0000, 0x0000, 0x0029, 0x0007,
  INFOLINE,       -1,       -1, G_TEXT    ,   /* Object 1 INFOVERS */
  NONE, NORMAL, (LONG)&rs_tedinfo[0],
  0x0002, 0x0001, 0x0025, 0x0001,
  INFOCOPY,       -1,       -1, G_IBOX    ,   /* Object 2 INFOLINE */
  NONE, NORMAL, (LONG)0x00011100L,
  0x0002, 0x0002, 0x0025, 0x0400,
         4,       -1,       -1, G_TEXT    ,   /* Object 3 INFOCOPY */
  NONE, NORMAL, (LONG)&rs_tedinfo[1],
  0x0002, 0x0003, 0x0025, 0x0001,
  INFOOK  ,       -1,       -1, G_TEXT    ,   /* Object 4  */
  NONE, NORMAL, (LONG)&rs_tedinfo[2],
  0x0002, 0x0005, 0x040D, 0x0600,
         6,       -1,       -1, G_BUTTON  ,   /* Object 5 INFOOK */
  SELECTABLE|DEFAULT|EXIT|FLAGS9|FLAGS10, NORMAL, (LONG)"OK",
  0x001E, 0x0005, 0x0009, 0x0201,
         0,       -1,       -1, G_TEXT    ,   /* Object 6  */
  LASTOB, NORMAL, (LONG)&rs_tedinfo[3],
  0x0002, 0x0006, 0x0017, 0x0600
};

OBJECT *rs_trindex[] =
{ &rs_object[0]    /* Tree  0 INFOPAGE */
};
