	.globl aes


	.bss
contrl:  ds.w 5
	.globl global
global:  ds.w 15
intin:   ds.w 16
intout:  ds.w 7
addrin:  ds.l 2
addrout: ds.l 1

	.text

aes:
		movem.l    d3/a2-a3,-(a7)
		lea.l      16(a7),a2
		lea.l      contrl,a3
		move.w     d0,(a3) /* opcode */
		move.w     d0,d1
		lsl.w      #2,d1
		lea.l      aesfntab-4*10,a0
		adda.w     d1,a0
/* fill contrl array */
		moveq.l    #1,d3
		bra.s      aes2
aes1:
		clr.w      d0
		move.b     (a0)+,d0
		move.w     d3,d1
		add.w      d1,d1
		move.w     d0,0(a3,d1.w)
		addq.w     #1,d3
aes2:
		cmp.w      #4,d3
		ble.s      aes1
/* fill intin array */
		clr.w      d3
		bra.s      aes4
aes3:
		move.w     d3,d0
		add.w      d0,d0
		move.w     (a2)+,intin-contrl(a3,d0.w)
		addq.w     #1,d3
aes4:
		cmp.w      2(a3),d3
		blt.s      aes3
/* fill addrin array */
		clr.w      d3
		bra.s      aes6
aes5:
		move.w     d3,d0
		lsl.w      #2,d0
		move.l     (a2)+,addrin-contrl(a3,d0.w)
		addq.w     #1,d3
aes6:
		cmp.w      6(a3),d3
		blt.s      aes5
/* call aes */
		lea.l      AES_pb,a0
		bsr.w      _crystal
/* copy intout parameters */
		moveq.l    #1,d3
		lea.l      intout-contrl(a3),a0
		bra.s      aes8
aes7:
		move.w     d3,d0
		add.w      d0,d0
		movea.l    (a2)+,a1
		move.w     0(a0,d0.w),(a1)
		addq.w     #1,d3
aes8:
		cmp.w      4(a3),d3
		blt.s      aes7
/* copy addrout parameters */
		clr.w      d3
		bra.s      aes10
aes9:
		move.w     d3,d0
		lsl.w      #2,d0
		movea.l    (a2)+,a1
		move.l     94(a3,d0.w),(a1) /* addrout-contrl */
		addq.w     #1,d3
aes10:
		cmp.w      8(a3),d3
		blt.s      aes9
/* return intout[0] */
		move.w     (a0),d0
		movem.l    (a7)+,d3/a2-a3
		rts

_crystal:
		move.l     a0,d1
		movem.l    d2-d3/a0-a3,-(a7)
		move.w     #200,d0
		trap       #2
		movem.l    (a7)+,d2-d3/a0-a3
		rts

	.data

AES_pb:
	dc.l contrl
	dc.l global
	dc.l intin
	dc.l intout
	dc.l addrin
	dc.l addrout

aesfntab:
		/* nintin,naddrin,nintout,naddrout */
		dc.b $00,$01,$00,$00
		dc.b $02,$01,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $00,$01,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $01,$01,$01,$00
		dc.b $02,$01,$00,$00
		dc.b $00,$01,$00,$00
		dc.b $01,$03,$01,$00
		dc.b $00,$01,$00,$00
		dc.b $00,$01,$00,$00
		dc.b $03,$05,$00,$00
		dc.b $05,$05,$00,$00
		dc.b $00,$01,$01,$00
		dc.b $02,$01,$00,$00
		dc.b $10,$07,$01,$00
		dc.b $02,$01,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $01,$01,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $01,$01,$02,$00
		dc.b $01,$01,$01,$00
		dc.b $02,$01,$02,$00
		dc.b $02,$01,$02,$00
		dc.b $03,$01,$01,$00
		dc.b $01,$01,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $01,$01,$01,$00
		dc.b $06,$01,$01,$00
		dc.b $04,$01,$01,$00
		dc.b $01,$03,$01,$00
		dc.b $02,$01,$01,$00
		dc.b $04,$02,$01,$00
		dc.b $08,$01,$01,$00
		dc.b $04,$03,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $01,$01,$01,$00
		dc.b $09,$01,$00,$00
		dc.b $01,$01,$01,$00
		dc.b $01,$01,$00,$00
		dc.b $00,$05,$01,$00
		dc.b $03,$03,$01,$00
		dc.b $02,$02,$01,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $04,$03,$00,$00
		dc.b $08,$03,$00,$00
		dc.b $06,$01,$00,$00
		dc.b $08,$01,$00,$00
		dc.b $08,$01,$00,$00
		dc.b $04,$01,$01,$00
		dc.b $03,$01,$01,$00
		dc.b $00,$05,$00,$00
		dc.b $01,$01,$01,$00
		dc.b $00,$05,$00,$00
		dc.b $00,$01,$01,$00
		dc.b $00,$01,$01,$00
		dc.b $00,$01,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$02,$02,$00
		dc.b $00,$02,$03,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $05,$01,$00,$00
		dc.b $05,$01,$00,$00
		dc.b $01,$01,$00,$00
		dc.b $01,$01,$00,$00
		dc.b $02,$05,$00,$00
		dc.b $06,$01,$00,$00
		dc.b $02,$01,$00,$00
		dc.b $01,$01,$00,$00
		dc.b $06,$05,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$01,$01,$00
		dc.b $00,$01,$00,$00
		dc.b $02,$01,$00,$01
		dc.b $02,$01,$01,$00
		dc.b $01,$01,$01,$00
		dc.b $00,$01,$01,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$01,$02,$00
		dc.b $03,$01,$02,$00
		dc.b $01,$01,$01,$00
		dc.b $01,$01,$01,$00
		dc.b $00,$01,$01,$00
		dc.b $00,$01,$02,$00
		dc.b $00,$01,$02,$00
		dc.b $00,$00,$02,$00
		dc.b $00,$00,$00,$00
		dc.b $00,$00,$00,$00
		dc.b $01,$05,$00,$00
		dc.b $00,$00,$00,$00
